package at.ac.tuwien.dbai.staff.dvorak.alternation.examples;

import gui.MainFrame;

import java.util.ArrayList;
import java.util.List;

import at.ac.tuwien.dbai.staff.dvorak.alternation.examples.GGAtm;
import at.ac.tuwien.dbai.staff.dvorak.alternation.examples.GGAtm.Worktape;
import at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.ComputationTree;

public class GraphGame {
	public static class Position {
		static int counter=0;
		public boolean winning;
		public int number;

		public Position(boolean winning) {
			super();
			this.winning = winning;
			this.number=counter;
			counter++;
		}

		public String toString() {
			return "Feld" + number+"; "+((Boolean)winning).toString();
		}

		public boolean equals(Position object){
			return (this.number==object.number);
		}

	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Graph<Position> graph=new Graph<Position>();
		List<Position> positions = new ArrayList<Position>();

		int n=10;
		for (int i=0; i<n; i++){
			positions.add(new Position(false));
			graph.addNode(positions.get(i));
		}
	
		positions.get(9).winning=true;

		graph.addEdge(positions.get(0), positions.get(1));
		graph.addEdge(positions.get(0), positions.get(8));
		
		graph.addEdge(positions.get(1), positions.get(2));
		graph.addEdge(positions.get(2), positions.get(3));

		graph.addEdge(positions.get(3), positions.get(4));
		graph.addEdge(positions.get(4), positions.get(5));
		graph.addEdge(positions.get(5), positions.get(6));

		graph.addEdge(positions.get(6), positions.get(7));
		graph.addEdge(positions.get(7), positions.get(8));
		graph.addEdge(positions.get(8), positions.get(9));

		Graph.Node<Position> startNode = graph.get(positions.get(0));


		GGAtm atm = new GGAtm();
		System.out.println(atm.compute(startNode, graph));
		System.out.println("#ComputationNodes: "+ atm.getComputationTree().size());
		ComputationTree<Worktape> cT = atm.getComputationTree();
	}
}
