package at.ac.tuwien.dbai.staff.dvorak.alternation.examples;
import java.util.Map;
import java.util.Set;


public class Horn2 {
	private at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.ATM<Inputtape,Worktape> atm;

	public class Inputtape {
		int goal;
		Map<Integer, Set<Set<Integer>>> rules;

		private Inputtape(int goal,Map<Integer, Set<Set<Integer>>> rules) {
			super();
			this.goal=goal;
			this.rules=rules;
		}
	}

    public class Worktape implements at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.InterfaceWorktape<Inputtape> {
    	Set<Integer> body;
    	int head;

    	private Worktape(){
    		super();
    	}

    	private Worktape(Worktape worktape) {
    		this.head = worktape.head;
    		this.body = worktape.body;
    	}

    	public void reset(Inputtape atmInputtape) {

    		this.body=null;
    		this.head = atmInputtape.goal;
    	}

    	public Worktape clone(){
    		return new Worktape(this);
    	};

    	public boolean equals( Object o ) {
        	if ( o == null ) return false;
            if (! o.getClass().equals(getClass()) ) return false;
            Worktape tape2=(Worktape) o;
    		if(this.body==null){
    			if(!(tape2.body==null)) return false;
    		} else {
    		  	if(!this.body.equals(tape2.body)) return false;
    		}
    		if(this.head!=tape2.head) return false;
            return true;
    	}

    	@Override
    	public int hashCode() {
    		final int prime = 31;
    		int result = 1;


    		result = prime * result + ((body == null) ? 0 : body.hashCode());
    		result = prime * result +  ((Object)head).hashCode();

    		return result;
    	}

    	public String toString() {
    		StringBuffer ausgabe= new StringBuffer();

    		if (body==null) {
    			ausgabe.append("body=null; ");
    		} else {
    			ausgabe.append("body=("+((Object)body).toString()+"); ");
    		}

    		 ausgabe.append("head=(" +((Object)head).toString()+"); ");
    		return ausgabe.toString();
    	}
    }

    private class head extends at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.State<Inputtape,Worktape>  {
    	
    	public at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.ResultTuple<Worktape> compute(Worktape atmWorktape) {
    		at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.ResultTuple<Worktape> atmResultTuple;
    		Worktape atmWorktape2;
    		atmResultTuple = new at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.ResultTuple<Worktape>(false, false, false);
    		atmWorktape2=atmWorktape.clone();
    		for(Set<Integer> rule: atmInputtape.rules.get(atmWorktape.head)){
    						{
    							atmWorktape.head=0;
    							atmWorktape.body=rule;
    						}
    		atmResultTuple.add((byte)1,atmWorktape);
    		atmWorktape=atmWorktape2.clone();
    					}
    		return atmResultTuple;
    	}
    }

    private class body extends at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.State<Inputtape,Worktape>  {
    	
    	public at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.ResultTuple<Worktape> compute(Worktape atmWorktape) {
    		at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.ResultTuple<Worktape> atmResultTuple;
    		Worktape atmWorktape2;
    		atmResultTuple = new at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.ResultTuple<Worktape>(false, false, true);
    		atmWorktape2=atmWorktape.clone();
    		for(Integer literal: atmWorktape.body){
    					{
    						atmWorktape.head=literal;
    						atmWorktape.body=null;				
    					}
    		atmResultTuple.add((byte)0,atmWorktape);
    		atmWorktape=atmWorktape2.clone();
    				}
    		return atmResultTuple;
    	}
    }

    public boolean compute(int goal,Map<Integer, Set<Set<Integer>>> rules) {

    	Inputtape atmInput = new Inputtape(goal,rules);
    	if (this.atm==null) {
    		Worktape atmWork = new  Worktape();
    		java.util.Map<Byte,at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.State<Inputtape,Worktape>> atmStates = new java.util.HashMap<Byte,at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.State<Inputtape,Worktape>>();

    		atmStates.put((byte)1,new body());
    		atmStates.put((byte)0,new head());

    		this.atm = new at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.ATMcyclic<Inputtape,Worktape>(atmStates, atmWork, (byte)0);
        }
        return atm.compute(atmInput);
    }

	public at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.ComputationTree<Worktape> getComputationTree(){
		at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.ComputationTree<Worktape> cT=this.atm.getComputationTree();
		cT.setStateIdToName((byte)1, "body");
		cT.setNameToStateId("body",(byte) 1);
		cT.setStateIdToName((byte)0, "head");
		cT.setNameToStateId("head",(byte) 0);

		return cT;
	}
}