package at.ac.tuwien.dbai.staff.dvorak.alternation.examples;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Random;
import java.util.Set;

import at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.ComputationTree;


public class PebbleTest {

	static void addrule (Set<List<String>> rules,String a, String b, String c){
		List<String> list = new ArrayList<String>();
		list.add(a);
		list.add(b);
		list.add(c);
		rules.add(list);
	}
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Set<String> pebbles= new HashSet<String>();
		Integer n=5;
		Integer m=20;
		for(int i=0;i<n;i++){
			pebbles.add(((Integer)i).toString());
		}
		Set<List<String>> rules=new HashSet<List<String>>();
		
		// generate rules
		Random r = new Random();
		int cnt = 0;
		Integer n1,n2,n3;
		System.out.println("Rules:");
		while (rules.size() < m) {	       
			n1 =r.nextInt(n);
	        n2 =r.nextInt(n);
	        n3 =r.nextInt(n);
	        while (n1==n2){
	        	n2 =r.nextInt(n);
	        }
	        while (n1==n3 | n2==n3){
	        	n3 = r.nextInt(n);
	        }	        
	        System.out.println("("+n1+","+n2+","+n3+")");
	        addrule(rules,n1.toString(),n2.toString(),n3.toString());	         
	   }
		System.out.println("------------------------");
		String goal =((Integer)(n)).toString();
		String[] startSet =new String[]{"0","1","2"};
		PEBBLE pebble_atm = new PEBBLE();

		System.out.println(pebble_atm.compute(pebbles, rules,goal,startSet));
		System.out.println("#ComputationNodes: "+ pebble_atm.getComputationTree().size());
		ComputationTree<PEBBLE.Worktape> cT=pebble_atm.getComputationTree();
		if (cT.size()<50) System.out.println(pebble_atm.getComputationTree());
		
		PEBBLE2 pebble2_atm = new PEBBLE2();

		System.out.println(pebble2_atm.compute(pebbles, rules,goal,startSet));
		System.out.println("#ComputationNodes: "+ pebble2_atm.getComputationTree().size());
		ComputationTree<PEBBLE2.Worktape> cT2=pebble2_atm.getComputationTree();
		if (cT2.size()<50) System.out.println(pebble2_atm.getComputationTree());
	}


}
