package at.ac.tuwien.dbai.staff.dvorak.alternation.examples;


public class TicTacToe {
	private at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.ATM<Inputtape,Worktape> atm;

	public class Inputtape {
		byte[] game;
		boolean crossPlayersTurn;

		private Inputtape(byte[] game,boolean crossPlayersTurn) {
			super();
			this.game=game;
			this.crossPlayersTurn=crossPlayersTurn;
		}
	}

    public class Worktape implements at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.InterfaceWorktape<Inputtape> {
    	byte[] paper;

    	private Worktape(){
    		super();
    	}

    	private Worktape(Worktape worktape) {
    		this.paper = worktape.paper.clone();
    	}

    	public void reset(Inputtape atmInputtape) {

    		this.paper = atmInputtape.game.clone();
    	}

    	public Worktape clone(){
    		return new Worktape(this);
    	};

    	public boolean equals( Object o ) {
        	if ( o == null ) return false;
            if (! o.getClass().equals(getClass()) ) return false;
            Worktape tape2=(Worktape) o;
    		if(this.paper==null){
    			if(!(tape2.paper==null)) return false;
    		} else {
    		    if(!java.util.Arrays.equals(this.paper,tape2.paper)) return false;
    		}
            return true;
    	}

    	@Override
    	public int hashCode() {
    		final int prime = 31;
    		int result = 1;


    		result =  prime * result + java.util.Arrays.hashCode(paper);

    		return result;
    	}

    	public String toString() {
    		StringBuffer ausgabe= new StringBuffer();
    		return ausgabe.toString();
    	}
    }

    private class start extends at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.State<Inputtape,Worktape>  {
    	
    	public at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.ResultTuple<Worktape> compute(Worktape atmWorktape) {
    		at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.ResultTuple<Worktape> atmResultTuple;
    		Worktape atmWorktape2;
    		if (atmInputtape.crossPlayersTurn){
    					atmResultTuple = new at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.ResultTuple<Worktape>(false, false, true);
    		atmWorktape2=atmWorktape.clone();
    		{
    						}
    		atmResultTuple.add((byte)1,atmWorktape);
    		atmWorktape=atmWorktape2.clone();
    		return atmResultTuple;
    				} else {
    					atmResultTuple = new at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.ResultTuple<Worktape>(false, false, true);
    		atmWorktape2=atmWorktape.clone();
    		{
    						}
    		atmResultTuple.add((byte)2,atmWorktape);
    		atmWorktape=atmWorktape2.clone();
    		return atmResultTuple;
    				}
    	}
    }

    private class crossPlayer extends at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.State<Inputtape,Worktape>  {
    	
    	public at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.ResultTuple<Worktape> compute(Worktape atmWorktape) {
    		at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.ResultTuple<Worktape> atmResultTuple;
    		Worktape atmWorktape2;
    		if(atmWorktape.paper[4]==2){
    					if ( atmWorktape.paper[0]==2 & atmWorktape.paper[8]==2) return at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.ResultTuple.REJECT;
    					if ( atmWorktape.paper[1]==2 & atmWorktape.paper[7]==2) return at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.ResultTuple.REJECT;
    					if ( atmWorktape.paper[2]==2 & atmWorktape.paper[6]==2) return at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.ResultTuple.REJECT;
    					if ( atmWorktape.paper[3]==2 & atmWorktape.paper[5]==2) return at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.ResultTuple.REJECT;
    				} 
    				if (atmWorktape.paper[0]==2 & atmWorktape.paper[1]==2 & atmWorktape.paper[2]==2) return at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.ResultTuple.REJECT;
    				if (atmWorktape.paper[0]==2 & atmWorktape.paper[3]==2 & atmWorktape.paper[6]==2) return at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.ResultTuple.REJECT;
    				if (atmWorktape.paper[2]==2 & atmWorktape.paper[5]==2 & atmWorktape.paper[8]==2) return at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.ResultTuple.REJECT;
    				if (atmWorktape.paper[6]==2 & atmWorktape.paper[7]==2 & atmWorktape.paper[8]==2) return at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.ResultTuple.REJECT;
    									
    				atmResultTuple = new at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.ResultTuple<Worktape>(false, false, false);
    		atmWorktape2=atmWorktape.clone();
    		for (int i=0;i<9;i++){
    						if (atmWorktape.paper[i]==0){
    							{
    								atmWorktape.paper[i]=1;
    							}
    		atmResultTuple.add((byte)2,atmWorktape);
    		atmWorktape=atmWorktape2.clone();
    						}
    					}
    		return atmResultTuple;
    	}
    }

    private class noughtPlayer extends at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.State<Inputtape,Worktape>  {
    	
    	public at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.ResultTuple<Worktape> compute(Worktape atmWorktape) {
    		at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.ResultTuple<Worktape> atmResultTuple;
    		Worktape atmWorktape2;
    		if(atmWorktape.paper[4]==1){
    					if ( atmWorktape.paper[0]==1 & atmWorktape.paper[8]==1) return at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.ResultTuple.ACCEPT;
    					if ( atmWorktape.paper[1]==1 & atmWorktape.paper[7]==1) return at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.ResultTuple.ACCEPT;
    					if ( atmWorktape.paper[2]==1 & atmWorktape.paper[6]==1) return at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.ResultTuple.ACCEPT;
    					if ( atmWorktape.paper[3]==1 & atmWorktape.paper[5]==1) return at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.ResultTuple.ACCEPT;
    				} 
    				if (atmWorktape.paper[0]==1 & atmWorktape.paper[1]==1 & atmWorktape.paper[2]==1) return at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.ResultTuple.ACCEPT;
    				if (atmWorktape.paper[0]==1 & atmWorktape.paper[3]==1 & atmWorktape.paper[6]==1) return at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.ResultTuple.ACCEPT;
    				if (atmWorktape.paper[2]==1 & atmWorktape.paper[5]==1 & atmWorktape.paper[8]==1) return at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.ResultTuple.ACCEPT;
    				if (atmWorktape.paper[6]==1 & atmWorktape.paper[7]==1 & atmWorktape.paper[8]==1) return at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.ResultTuple.ACCEPT;

    				if(atmWorktape.paper[0]!=0 & atmWorktape.paper[1]!=0 & atmWorktape.paper[2]!=0 & atmWorktape.paper[3]!=0 & atmWorktape.paper[4]!=0 & atmWorktape.paper[5]!=0 & atmWorktape.paper[6]!=0 & atmWorktape.paper[7]!=0 & atmWorktape.paper[8]!=0){
    					return at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.ResultTuple.REJECT;
    				}		
    				atmResultTuple = new at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.ResultTuple<Worktape>(false, false, true);
    		atmWorktape2=atmWorktape.clone();
    		for (int i=0;i<9;i++){
    						if (atmWorktape.paper[i]==0){
    							{
    								atmWorktape.paper[i]=2;
    							}
    		atmResultTuple.add((byte)1,atmWorktape);
    		atmWorktape=atmWorktape2.clone();
    						}
    					}
    		return atmResultTuple;
    	}
    }

    public boolean compute(byte[] game,boolean crossPlayersTurn) {

    	Inputtape atmInput = new Inputtape(game,crossPlayersTurn);
    	if (this.atm==null) {
    		Worktape atmWork = new  Worktape();
    		java.util.Map<Byte,at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.State<Inputtape,Worktape>> atmStates = new java.util.HashMap<Byte,at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.State<Inputtape,Worktape>>();

    		atmStates.put((byte)0,new start());
    		atmStates.put((byte)2,new noughtPlayer());
    		atmStates.put((byte)1,new crossPlayer());

    		this.atm = new at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.ATMacyclic<Inputtape,Worktape>(atmStates, atmWork, (byte)0);
        }
        return atm.compute(atmInput);
    }

	public at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.ComputationTree<Worktape> getComputationTree(){
		at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.ComputationTree<Worktape> cT=this.atm.getComputationTree();
		cT.setStateIdToName((byte)0, "start");
		cT.setNameToStateId("start",(byte) 0);
		cT.setStateIdToName((byte)2, "noughtPlayer");
		cT.setNameToStateId("noughtPlayer",(byte) 2);
		cT.setStateIdToName((byte)1, "crossPlayer");
		cT.setNameToStateId("crossPlayer",(byte) 1);

		return cT;
	}
}