package at.ac.tuwien.dbai.staff.dvorak.alternation.runtime;
/**
 * abstract class representing a state of the alternating machine
 * 
 * @author Wolfgang Dvorak
 *
 * @param <GInputtape> container for the input variables
 * @param <GWorktape> container for the work variables
 */
public abstract class State<GInputtape,GWorktape>  {
	
	public GInputtape atmInputtape;
	
	/**
	 * computes the Result from a worktape 
	 * @param worktape Work variables
	 * @return Either accept / reject or a set of successors and a Quantifier (existential or universal).
	 */
	public abstract ResultTuple<GWorktape> compute(GWorktape worktape);
	
	/**
	 * 
	 * @param input the actual input from the alternating machine
	 */
	public void setInput(GInputtape input) {
		this.atmInputtape=input;
	}
}
